Description

I am opening a new issue as requested on #6378. On comment 16 of that issue gives the idea of what is the bug.

Steps to reproduce the problem:

1. Create an issue with start date and due date. (Let' say May 27 and May 31). I will refer this issue as IssueA.

2. Create another issue. I will refer this issue as IssueB.

3. Create a third issue with start date and due date as a subtask of IssueB. (Let's use the same dates: May 27 and May 31).

4. Modify IssueB and add a relation to "follow" IssueA. This will "push" IssueB and its subtask forward on time.

5. Create a fourth issue with start date and due date as a subtask of IssueB. (Let's use May 29 and June 4).

1. Redime will create the issue successfully.

6. Try to modify this last created issue and change something with the exception of the start/due dates (may be description, title,

anything).

1. This time, Redmine will raise an "Start date is invalid" error and won't let modify the issue.

Expected behaviour:

1. Trying to create the last issue on the steps above should raise the invalid start date error.

2. On the displayed error, more information is needed. People may become crazy trying to figure out why that date is invalid. May

be something line "Start/End date overlaps with a preceding or following issue"?

Note: It also affects the demo that was at http://demo.redmine.org the same date I posted this issue. In fact, I did the above

steps on the online demo before posting this issue to confirm its current existence.

Related issues:

Related to Redmine - Defect #6378: Subtask - Start is invalid Reopened 2010-09-13

Associated revisions

Revision 11926 - 2013-06-04 19:17 - Jean-Philippe Lang

Adds a specific error message for when the start date is too earlier than the minimum start date (#14086).

Revision 11927 - 2013-06-04 19:32 - Jean-Philippe Lang

Adjusts error message in tests (#14086).

Revision 11928 - 2013-06-04 19:41 - Jean-Philippe Lang

Really adjusts error message in tests (#14086).

Revision 11931 - 2013-06-05 21:56 - Jean-Philippe Lang

Don't validate start date when updating an issue without changing it (#14086).

History

#1 - 2013-06-04 01:18 - Edgar H

I would like to suggest this to be marked with high priority because this causes loss of data silently. This is related to automatic updates through

repository commits:

If I add a reference to the issue including "refs #ISSUEID" in the comment, that commit is not added to the "Associated revisions" of the issue.

If I log time including "refs #ISSUEID @XhYm" in the comment, the time is not logged.

If I mark the issue as resolved using "fixes #ISSUEID" in the comment, the issue is not marked as resolved.
#2 - 2013-06-04 19:04 - Jean-Philippe Lang

Edgar H wrote:

Expected behaviour:

1. Trying to create the last issue on the steps above should raise the invalid start date error.

 These checks were improved lately and current trunk is now working as expected, you get an "invalid start date" error when trying to create the last

issue.

2. On the displayed error, more information is needed. People may become crazy trying to figure out why that date is invalid. May be something

line "Start/End date overlaps with a preceding or following issue"?

 Very true, this error message should be improved and include the minimum start date. Maybe someting like "Start date : cannot be earlier than

05/31/2013 because of preceding issues"?

#3 - 2013-06-04 22:18 - Edgar H

Jean-Philippe Lang wrote:

These checks were improved lately and current trunk is now working as expected, you get an "invalid start date" error when trying to create the

last issue.

 Then, sorry about this. Hope these improved checks be included soon in a stable release.

Very true, this error message should be improved and include the minimum start date. Maybe someting like "Start date : cannot be earlier than

05/31/2013 because of preceding issues"?

 Yes! That would be a great improvement! And I can see that you are already working on it :)

#4 - 2013-06-05 22:06 - Jean-Philippe Lang

- Subject changed from Start date is invalid when updating subtask to Better handling of issue start date validation

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version set to 2.4.0

- Resolution set to Fixed

Edgar H wrote:

I would like to suggest this to be marked with high priority because this causes loss of data silently. This is related to automatic updates through

repository commits

 Yes, if a start date becomes invalid for any reasons, automatic updates (eg. commits, replies by emails) are all stuck. r11931 now prevents that by

skipping validation if the start date is not changed during the update.

I'm closing it as all the problems reported here can be considered as fixed, thanks for pointing this out.
